package bin

import (

)

type BindCustomerDataTabApi struct {
}

// GetPage 获取客户表能耗数据表列表
// @Summary 获取客户表能耗数据表列表
// @Description 获取客户表能耗数据表列表
// @Tags 客户表能耗数据表
             
// @Param pageSize query int false "页条数"
// @Param pageIndex query int false "页码"
// @Success 200 {object} response.Response{data=response.Page{list=[]models.BindCustomerDataTab}} "{"code": 200, "data": [...]}"
// @Router /api/v1/bin [get]
// @Security Bearer
func (api *BindCustomerDataTabApi) GetPage(c *gin.Context) {
    req := dto.BindCustomerDataTabGetPageReq{}
    s := service.BindCustomerDataTab{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
   	if err != nil {
   		e.Logger.Error(err)
   		e.Error(500, err, err.Error())
   		return
   	}

	p := actions.GetPermissionFromContext(c)
	list := make([]models.BindCustomerDataTab, 0)
	var count int64

	err = s.GetPage(&req, p, &list, &count)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取客户表能耗数据表失败，\r\n失败信息 %s", err.Error()))
        return
	}

	e.PageOK(list, int(count), req.GetPageIndex(), req.GetPageSize(), "查询成功")
}

// GetBindCustomerDataTab 获取客户表能耗数据表
// @Summary 获取客户表能耗数据表
// @Description 获取客户表能耗数据表
// @Tags 客户表能耗数据表
// @Param id path int false "id"
// @Success 200 {object} response.Response{data=models.BindCustomerDataTab} "{"code": 200, "data": [...]}"
// @Router /api/v1/bin/{id} [get]
// @Security Bearer
func  (api *BindCustomerDataTabApi) Get(c *gin.Context) {
	req := dto.BindCustomerDataTabGetReq{}
	s := service.BindCustomerDataTab{}
    err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	var object models.BindCustomerDataTab

	p := actions.GetPermissionFromContext(c)
	err = s.Get(&req, p, &object)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取客户表能耗数据表失败，\r\n失败信息 %s", err.Error()))
        return
	}

	e.OK( object, "查询成功")
}

// saveBindCustomerDataTab 创建客户表能耗数据表
// @Summary 创建客户表能耗数据表
// @Description 创建客户表能耗数据表
// @Tags 客户表能耗数据表
// @Accept application/json
// @Product application/json
// @Param data body dto.BindCustomerDataTabInsertReq true "data"
// @Success 200 {object} response.Response	"{"code": 200, "message": "添加成功"}"
// @Router /api/v1/bin [post]
// @Security Bearer
func  (api *BindCustomerDataTabApi) Save(c *gin.Context) {
    req := dto.BindCustomerDataTabInsertReq{}
    s := service.BindCustomerDataTab{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
    if err != nil {
        e.Logger.Error(err)
        e.Error(500, err, err.Error())
        return
    }
	// 设置创建人
	req.SetCreateBy(user.GetUserId(c))

	err = s.Save(&req)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("创建客户表能耗数据表失败，\r\n失败信息 %s", err.Error()))
        return
	}

	e.OK(req.GetId(), "创建成功")
}

// UpdateBindCustomerDataTab 修改客户表能耗数据表
// @Summary 修改客户表能耗数据表
// @Description 修改客户表能耗数据表
// @Tags 客户表能耗数据表
// @Accept application/json
// @Product application/json
// @Param id path int true "id"
// @Param data body dto.BindCustomerDataTabUpdateReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "修改成功"}"
// @Router /api/v1/bin/{id} [put]
// @Security Bearer
func (api *BindCustomerDataTabApi) Update(c *gin.Context) {
    req := dto.BindCustomerDataTabUpdateReq{}
    s := service.BindCustomerDataTab{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
    if err != nil {
        e.Logger.Error(err)
        e.Error(500, err, err.Error())
        return
    }
	req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Update(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("修改客户表能耗数据表失败，\r\n失败信息 %s", err.Error()))
        return
	}
	e.OK( req.GetId(), "修改成功")
}

// DelBindCustomerDataTab 删除客户表能耗数据表
// @Summary 删除客户表能耗数据表
// @Description 删除客户表能耗数据表
// @Tags 客户表能耗数据表
// @Param data body dto.BindCustomerDataTabDeleteReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "删除成功"}"
// @Router /api/v1/bin [delete]
// @Security Bearer
func (api *BindCustomerDataTabApi) Delete(c *gin.Context) {
    s := service.BindCustomerDataTab{}
    req := dto.BindCustomerDataTabDeleteReq{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
    if err != nil {
        e.Logger.Error(err)
        e.Error(500, err, err.Error())
        return
    }

	// req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Delete(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("删除客户表能耗数据表失败，\r\n失败信息 %s", err.Error()))
        return
	}
	e.OK( req.GetId(), "删除成功")
}
