package com.dpc.app.iot.domain;

import java.util.Date;
import java.util.ArrayList;
import java.util.List;
import javax.persistence.*;
import com.dpc.app.jpa.entity.TenantEntity;
import lombok.Data;
import lombok.NoArgsConstructor;
/**
 * 图素表
 * @author robnote
 * @since  2023-02-07 15:20:58.802532 &#43;0800 &#43;0800
 */
@Entity
@Table(name="dpc_graphic_material_tab")
@Data
@NoArgsConstructor
public class DpcGraphicMaterialTab extends TenantEntity {

  @Column(columnDefinition = "bigint(20)  comment 'id IDENTITY (1,1) NOT NULL '")
  private Long id;
 
  @Column(columnDefinition = "varchar(50)  comment '图素名称 '")
  private String name;
 
  @Column(columnDefinition = "varchar(20)  comment '图素类型 基本、特殊、能量、设备、通信等'")
  private String imgType;
 
  @Column(columnDefinition = "varchar(150)  comment '图素的存放地址 '")
  private String path;
 
  @Column(columnDefinition = "char(1)  comment '上传类型 0:系统 1:自定义'")
  private String uploadType;
 
  @Column(columnDefinition = "varchar(50)  comment '企业id '")
  private String companyId;
 
  @Column(columnDefinition = "varchar(50)  comment '用户id 创建数据者id'")
  private String userId;
 
  @Column(columnDefinition = "char(1)  comment '删除FLG 0:未删除 1:删除'")
  private String delFlg;
 
  
  
  
  
  @Column(columnDefinition = "varchar(100)  comment '备用字段1 '")
  private String reserveCol1;
 
  @Column(columnDefinition = "varchar(100)  comment '备用字段2 '")
  private String reserveCol2;
 
  @Column(columnDefinition = "varchar(100)  comment '备用字段3 '")
  private String reserveCol3;
 
  @Column(columnDefinition = "varchar(100)  comment '备用字段4 '")
  private String reserveCol4;
 
  @Column(columnDefinition = "varchar(100)  comment '备用字段5 '")
  private String reserveCol5;
 
}
