package service

import (
	"errors"
)

type {{.ClassName}}Service struct {
}

// GetPage 获取{{.ClassName}}列表
func (e *{{.ClassName}}Service) GetPage(c *dto.{{.ClassName}}GetPageReq, p *actions.DataPermission, list *[]models.{{.ClassName}}, count *int64) error {
	var err error
	var data models.{{.ClassName}}

	err = e.Orm.Model(&data).
		Scopes(
			cDto.MakeCondition(c.GetNeedSearch()),
			cDto.Paginate(c.GetPageSize(), c.GetPageIndex()),
			actions.Permission(data.TableName(), p),
		).
		Find(list).Limit(-1).Offset(-1).
		Count(count).Error
	if err != nil {
		e.Log.Errorf("{{.ClassName}}Service GetPage error:%s \r\n", err)
		return err
	}
	return nil
}

// Get 获取{{.ClassName}}对象
func (e *{{.ClassName}}Service) Get(d *dto.{{.ClassName}}GetReq, p *actions.DataPermission, model *models.{{.ClassName}}) error {
	var data models.{{.ClassName}}

	err := e.Orm.Model(&data).
		Scopes(
			actions.Permission(data.TableName(), p),
		).
		First(model, d.GetId()).Error
	if err != nil && errors.Is(err, gorm.ErrRecordNotFound) {
		err = errors.New("查看对象不存在或无权查看")
		e.Log.Errorf("Service Get{{.ClassName}} error:%s \r\n", err)
		return err
	}
	if err != nil {
		e.Log.Errorf("db error:%s", err)
		return err
	}
	return nil
}

// Insert 创建{{.ClassName}}对象
func (e *{{.ClassName}}Service) Save(c *dto.{{.ClassName}}InsertReq) error {
    var err error
    var data models.{{.ClassName}}
    c.Generate(&data)
	err = e.Orm.Create(&data).Error
	if err != nil {
		e.Log.Errorf("{{.ClassName}}Service Insert error:%s \r\n", err)
		return err
	}
	return nil
}

// Update 修改{{.ClassName}}对象
func (e *{{.ClassName}}Service) Update(c *dto.{{.ClassName}}UpdateReq, p *actions.DataPermission) error {
    var err error
    var data = models.{{.ClassName}}{}
    e.Orm.Scopes(
            actions.Permission(data.TableName(), p),
        ).First(&data, c.GetId())
    c.Generate(&data)

    db := e.Orm.Save(&data)
    if err = db.Error; err != nil {
        e.Log.Errorf("{{.ClassName}}Service Save error:%s \r\n", err)
        return err
    }
    if db.RowsAffected == 0 {
        return errors.New("无权更新该数据")
    }
    return nil
}

// Remove 删除{{.ClassName}}
func (e *{{.ClassName}}Service) Delete(d *dto.{{.ClassName}}DeleteReq, p *actions.DataPermission) error {
	var data models.{{.ClassName}}

	db := e.Orm.Model(&data).
		Scopes(
			actions.Permission(data.TableName(), p),
		).Delete(&data, d.GetId())
	if err := db.Error; err != nil {
        e.Log.Errorf("Service Remove{{.ClassName}} error:%s \r\n", err)
        return err
    }
    if db.RowsAffected == 0 {
        return errors.New("无权删除该数据")
    }
	return nil
}
